#include <fstream>
#include <iostream>

#define modulo 1000000007
using namespace std;

long long t,n,k,d,x1[40],x2[40],a[40][40],b[40][40];
void unitate(long long k,long long b[][40])
{
    for(int i=1;i<=k;i++)
        b[i][i]=1;
}
void attrib(long long k,long long a[][40], long long b[][40])
{
    for (int i=1;i<=k;i++)
        for (int j=1;j<=k;j++)
            a[i][j]=b[i][j];
}
void inmult(long long k, long long a[][40], long long b[][40], long long c[][40])
{
    for (int i=1;i<=k;i++)
        for (int j=1;j<=k;j++)
        {
            c[i][j]=0;
            for (int x=1;x<=k;x++)
                c[i][j]=(c[i][j]+(a[i][x]*b[x][j])% modulo) % modulo;
        }
}

void power (long long n, long long k, long long a[][40], long long b[][40])
{
    long long c[40][40];
    while (n)
    {
        if (n%2)
        {
            inmult(k,a,b,c);
            attrib(k,b,c);
        }
        inmult(k,a,a,c);
        attrib(k,a,c);
        n=n/2;
    }
}
void initmat (long long a[][40])
{
    for (int i=1;i<=36;i++)
        if (i%4)
            a[i][i+1]=1;
        else
        if (i==4)
            a[i][3]=a[i][7]=a[i][11]=1;
        else
        if (i==8)
            a[i][15]=a[i][19]=a[i][23]=1;
        else
        if (i==12)
            a[i][27]=a[i][31]=a[i][35]=2;
        else
        if (i==16)
            a[i][2]=a[i][6]=a[i][10]=1;
        else
        if (i==20)
            a[i][14]=a[i][18]=a[i][22]=1;
        else
        if (i==24)
            a[i][26]=a[i][30]=a[i][34]=2;
        else
        if (i==28)
            a[i][1]=a[i][5]=a[i][9]=1;
        else
        if (i==32)
            a[i][13]=a[i][17]=a[i][21]=1;
        else
            a[i][25]=a[i][29]=a[i][33]=2;
}
void initvect(long long x[])
{
    x[ 1]=0;x[ 2]=1;x[ 3]=1;x[ 4]=2;
    x[ 5]=1;x[ 6]=0;x[ 7]=1;x[ 8]=1;
    x[ 9]=0;x[10]=1;x[11]=0;x[12]=2;
    x[13]=1;x[14]=0;x[15]=1;x[16]=1;
    x[17]=0;x[18]=1;x[19]=0;x[20]=1;
    x[21]=0;x[22]=0;x[23]=1;x[24]=0;
    x[25]=0;x[26]=1;x[27]=0;x[28]=1;
    x[29]=0;x[30]=0;x[31]=1;x[32]=0;
    x[33]=0;x[34]=0;x[35]=0;x[36]=1;
}
int main()
{
    int sol[5]={0,0,3,3,9};
    cin>>n;
    initmat(a);
    initvect(x1);
    unitate(36,b);
    if (n<=4)
        cout<<sol[n]<<endl;
    else
    {
        power(n-5,36,a,b);
        for (int i=1;i<=36;i++)
        {
            x2[i]=0;
            for (int j=1;j<=36;j++)
                x2[i]=(x2[i]+b[i][j]*x1[j]) % modulo;
        }
        t=0;
        for (int j=1;j<=36;j=j+4)
            t=(t+6*x2[j]) % modulo;
        cout<<t<<endl;
    }
    return 0;
}
