#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp> //required
// #include <ext/pb_ds/tree_policy.hpp> //required

// using namespace __gnu_pbds; 
using namespace std;

void debug_out() { cerr << endl; }
template<class T> ostream& prnt(ostream& out, T v) { out << v.size() << '\n'; for(auto e : v) out << e << ' '; return out;}
template<class T> ostream& operator<<(ostream& out, vector <T> v) { return prnt(out, v); }
template<class T> ostream& operator<<(ostream& out, set <T> v) { return prnt(out, v); }
template<class T1, class T2> ostream& operator<<(ostream& out, map <T1, T2> v) { return prnt(out, v); }
template<class T1, class T2> ostream& operator<<(ostream& out, pair<T1, T2> p) { return out << '(' << p.st << ' ' << p.nd << ')'; }
template <typename Head, typename... Tail> void debug_out(Head H, Tail... T) { cerr << " " << H; debug_out(T...);}
// template <typename T> using ordered_set =  tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;  // ordered_set <long long> s; // order_of_key(value)

#define dbg(...) cerr << #__VA_ARGS__ << " ->", debug_out(__VA_ARGS__)
#define dbg_v(x, n) do{cerr<<#x"[]: ";for(long long _=0;_<n;++_)cerr<<x[_]<<" ";cerr<<'\n';}while(0)
#define dbg_ok cerr<<"OK!\n"

#define st first
#define nd second


const long long N = 44;
long long n, k, m, a, b, ind[N], res[2][N], r[N], ans;
long long vec[2][N];
vector <long long> v[2];
long long g[N];

long long get_ans(long long mask, long long gen) {
	long long ret = 0;
	for(long long i = 0; i < v[gen].size(); i++)
		if((1LL <<  i) & mask)
			ret += r[v[gen][i]];
	return ret;
}

bool ok(long long mask, long long gen) {
	// dbg(mask, gen);
	long long vec_msk = 0;
	for(long long i = 0; i < v[gen].size(); i++)
		if((1LL <<  i) & mask)
			vec_msk |= vec[gen][i];
	return (vec_msk & mask) == 0;
}

void upd(long long &a, long long b) {
	if(b > a) a = b;
}

void populate(long long gen) {

	for(long long i = 1; i < (1LL <<  v[gen].size()); i++)
		if(ok(i, gen))
			upd(res[gen][__builtin_popcount(i)], get_ans(i, gen));
}

int main() {
	ios_base::sync_with_stdio(false);

	cin >> n;

	char gen;
	memset(res, -1, sizeof res);

	for(long long i = 1; i <= n; i++) {
		cin >> gen >> r[i];
		if(gen == 'g') g[i] = 1;
		// dbg(gen, r[i], g[i]);

		ind[i] = v[g[i]].size();
		v[g[i]].push_back(i);

	}
	cin >> m;
	for(long long i = 1; i <= m; i++) {
		cin >> a >> b;
		// dbg(a, b);
		vec[g[a]][ind[a]] += (1LL <<  ind[b]);
		vec[g[a]][ind[b]] += (1LL <<  ind[a]);
	}

	// dbg(v[0]);
	// dbg(v[1]);

	populate(0);
	populate(1);

	// dbg_v(res[0], 4);
	// dbg_v(res[1], 4);

	res[0][0] = res[1][0] = 0;
	for(long long i = 0; i <= min(v[0].size(), v[1].size()); i++) {
		if(res[0][i] == -1 || res[1][i] == -1) 
			break;
		ans = max(ans, res[0][i] + res[1][i]);
	}
	cout << ans << '\n';

}	
